function setUnitControllToPlayer (ui, pi)
	local currUnit = gplayers[pi].controllsUnit
	if currUnit then gunits[currUnit].playerControlled = nil end
	gunits[ui].playerControlled = pi
	gplayers[pi].controllsUnit = ui
end


function getPlayersInputs ()
	for i,p in ipairs(gplayers) do
		--p.wantLeft, p.wantRight, p.wantUp, p.wantDown, p.wantShot = false,false,false,false,false
		p.want.right=false
		p.want.left=false
		p.want.up=false
		p.want.down=false
		p.want.shot=false
		--keyboard
		if LKB.isDown(p.keyLeft) then p.want.left = true end
		if LKB.isDown(p.keyRight) then p.want.right = true end
		if LKB.isDown(p.keyUp) then p.want.up = true end
		if LKB.isDown(p.keyDown) then p.want.down = true end
		if LKB.isDown(p.keyShot) then p.want.shot = true end
		--gamepad
		--TODO
	end
end

function getPlayerWant (p)
	return p.want
end

function addPlayer (keyLeft,keyRight,keyUp,keyDown,keyShot)
	local newPlayer = {isActive = true, 
	keyLeft = keyLeft or "a",
	keyRight = keyRight or "d",
	keyUp = keyUp or "w",
	keyDown = keyDown or "s",
	keyShot = keyShot or "x",	
	want = {left=false,right=false,up=false,down=false,shot=false},
	joystick = nil, --joystick-object
	joysticki = nil, --joystick-index
	x = tile2world(3),	--FIXME: player should not have x,y coordinates, health etc.
	y = tile2world(3),	--		 instead player will just be the controller and control "units" or "objects"
	xs=0,
	ys=0,
	tx=3,
	ty=3,
	angle=0,
	}
	table.insert (gplayers, newPlayer)
end

--debug/test functions:
function printPlayerWant (p,x,y)
	local bs = {[true]="x", [false]="-"}
	local x=x or 400
	local y=y or 200
	LG.print("<>^vS", x, y)
	LG.print (bs[p.want.left]..bs[p.want.right]..bs[p.want.up]..bs[p.want.down]..bs[p.want.shot], x, y+15)
	LG.print ("tile target:"..p.tox .."/"..p.toy,x,y+30)
end

function printAllPlayers (x,y)
	LG.setFont (gFont.small)
	local x=x or 500
	local y=y or 500
	for i,p in ipairs(gplayers) do
		LG.print ("player #"..i,x,y)
		printPlayerWant (p, x,y+40)
		y=y+60
	end
end
