function addUnit (tx,ty)
	local newUnit = {isActive = true, 
	want={left=false,right=false,up=false,shot=false},
	x = tile2world(tx),
	y = tile2world(ty),
	xs=0,
	ys=0,
	tx=tx,
	ty=ty,
	angle=0,
	color = nil,
	movementFunction = movementPacman,
	drawFunction = drawPacman
	}
	table.insert (gunits, newUnit)
end

function movementSpaceship(self, dt)
	print (self.x,self.y, self.xs)
	local speed = 5
	local m=speed*dt
	if self.want.left then self.angle=self.angle+4*dt end
	if self.want.right then self.angle=self.angle-4*dt end
	newangle = self.angle		--rotation is always allowed, so self.angle gets changed directly here and just returned for info
	local newxs=self.xs or 0
	local newys=self.ys or 0
	if self.ty > 100 then newys=newys+(dt*5) end	--gravity
	if self.want.up then
		newxs=self.xs+sin(self.angle)*m
		newys=self.ys+cos(self.angle)*m
	end		
	local newx=self.x+newxs
	local newy=self.y+newys
	
	return {newx=newx,newy=newy,newangle=newangle, newxs=newxs, newys=newys}
end

function movementPacman(self, dt)
	print (self.x,self.y, self.xs)
	local newx=self.x
	local newy=self.y
	local speed = 200
	local m=speed*dt
	local newangle = self.angle
	if self.want.left then newx=newx-m 
	elseif self.want.right then newx=newx+m end
	if self.want.up then newy=newy-m 
	elseif self.want.down then newy=newy+m end
	newxs=newx-self.x
	newys=newy-self.y
	--rotate unit towards movement vector, if it has moved.
	if newxs ~= 0 or newys ~= 0 then
		newangle= math.atan2(newxs,newys)
	end
	return {newx=newx,newy=newy,newangle=newangle, newxs=newxs, newys=newys}
end


function updateUnitsPhysics (dt)
local speed = 5
	local m=speed*dt

	for i,u in ipairs(gunits) do
		---
		--always update which tile unit is on
		u.tx=world2tile(u.x)
		u.ty=world2tile(u.y)
		
		u.tox=u.tx
		u.toy=u.ty
		local newx=u.x	--newx/newy used for checking collision. if okay, then x=newx
		local newy=u.y
		local newxs=u.xs
		local newys=u.ys
		local dirx=0
		local diry=0
		local wx=0		--atm not needed for physics. maybe later for animation?
		local wy=0
		--[[ pacman style, works
		if p.wantLeft then dirx=-1 wx=true end
		if p.wantRight then dirx=1 wy=true end
		if p.wantUp then diry=-1 wy=true end
		if p.wantDown then diry=1 wy=true end	
		if p.wantLeft then p.tox = p.tx-1 wx=true end
		if p.wantRight then p.tox = p.tx+1 wy=true end
		if p.wantUp then p.toy = p.ty-1 wy=true end
		if p.wantDown then p.toy = p.ty+1 wy=true end	
		newx=p.x+dirx*m
		newy=p.y+diry*m
		--]]
		--[[car style, works
		if p.wantLeft then p.angle=p.angle+3*dt end
		if p.wantRight then p.angle=p.angle-3*dt end
		if p.wantUp then dirx=sin(p.angle)  diry=cos(p.angle) end
		if p.wantDown then dirx=sin(p.angle)  diry=cos(p.angle) end
		if p.wantUp then
			newx=p.x+dirx*m
			newy=p.y+diry*m
		end
		if p.wantDown then
			newx=p.x-dirx*m
			newy=p.y-diry*m
		end
		--]]
		--spaceship, works--
		--[[
		if u.want.left then u.angle=u.angle+4*dt end
		if u.want.right then u.angle=u.angle-4*dt end
		local newxs=u.xs
		local newys=u.ys
		if u.ty > 100 then newys=newys+(dt*5) end	--gravity
		if u.want.up then
			newxs=u.xs+sin(u.angle)*m
			newys=u.ys+cos(u.angle)*m
		end
		
		newx=u.x+newxs
		newy=u.y+newys
		--]]
		print (i)
		local new = u:movementFunction(dt)
		newx=new.newx
		newy=new.newy
		newxs=new.newxs
		newys=new.newys
		newangle=new.newangle
		u.angle=newangle
		-----collission:
		local allowX=false
		local allowY=false
		--check corners of player
		if not colCornersCheckBlock (level, newx,u.y,PLAYERRADIUS) then
			allowX=true
		end
		if not colCornersCheckBlock (level, u.x,newy,PLAYERRADIUS) then
			allowY=true
		end  
		--anti-stuck: ist auf freiem tile aber hängt mit einer ecke in wand
		if not allowX and not allowY and not isBlock(level, u.tx, u.ty) and abs(u.xs)<0.1 and abs(u.ys)<0.1 then
			u.x = tile2world (u.tx)
			u.y = tile2world (u.ty)
			dbgtxt=dbgtxt.."antistuck!"
		end
		--bounce
		if allowX then u.x=newx  u.xs=newxs else u.xs=-u.xs/20 end
		if allowY then u.y=newy  u.ys=newys else u.ys=-u.ys/20 end
	end
end



function updateUnitsWant ()
	for i,u in ipairs(gunits) do
		if u.playerControlled then
			u.want = getPlayerWant (gplayers[u.playerControlled])
		else
			u.want =  wantToXY (u, gunits[gplayers[1].controllsUnit].x,gunits[gplayers[1].controllsUnit].y)--getRandomWant()
	
		end
	end
end


function drawUnits (vx1, vy1, vx2, vy2)
	LG.setColor(1, 1, 0, 1)
	LG.print ("drawUnits()",500,200)
	local drawnUnits = 0
	for i,u in ipairs(gunits) do
			--visibility check
			if vx1 and pointInRect (u.x, u.y, vx1,vy1, vx2, vy2) then 
				drawnUnits = drawnUnits+1
				--LG.setColor(1, 0, 0, 1)
				if u.playerControlled then LG.setColor(1, 1, 0, 1) end
				--drawShip (u.x, u.y, u.angle, PLAYERRADIUS)
				u.drawFunction (u.x, u.y, u.angle, u.want)
				LG.print ("u"..i,u.x,u.y+10)
			--	LG.line (u.x, u.y, 20,20)
				
				--LG.circle("line", p.x,p.y, PLAYERRADIUS, 4)
	--debug:
				--LG.print ("player"..i,p.x,p.y)
			--	local dx=500
		--		local dy=500
			--	LG.print ("player iXY:" .. i.." / ".. p.x.." / ".. p.y, dx,dy+20+i*60)
				
			--	LG.print ("player tileXY:" .. i.." / ".. p.tx.." / ".. p.ty, dx,dy+i*60)
				
				
				if debug then
					LG.setColor (1,0,0,1)
					LG.circle("line",tile2world (u.tx), tile2world (u.ty), PLAYERRADIUS, 4)
					LG.circle("line",tile2world (u.tox), tile2world (u.toy), PLAYERRADIUS, 6)
					LG.setColor(1, rnd(0,10)/10, 0, 1)
					LG.rectangle ("line", u.x-PLAYERRADIUS, u.y-PLAYERRADIUS,   PLAYERRADIUS*2, PLAYERRADIUS*2)  
					LG.setColor(1, rnd(0,10)/10, 0, 0.5)
					LG.rectangle ("fill",tile2world(p.tox)-(TILESIZE/2), tile2world(u.toy)-(TILESIZE/2), TILESIZE,TILESIZE)
					LG.line (u.x,u.y,u.x+math.sin(u.angle)*PLAYERRADIUS*2, u.y+math.cos(u.angle)*PLAYERRADIUS*2)
				end
			end
	end
	return drawnUnits
end

function wantToXY (self, targetX, targetY)
	local up,down,left,right,shot=false,false,false,false,false
	local d = 50
	if self.x - targetX > 50 then left=true end
	if self.x - targetX < -50 then right=true end
	if self.y - targetY > 50 then up=true end
	if self.y - targetY < -50 then down=true end

--	if self.y > targetY then up=true else down=true end 

	return {up=up, left=left, right=right, down=down, shot=shot}

end

function getRandomWant ()
	local up,down,left,right,shot=false,false,false,false,false
	local trueAndFalse = {true, false, true, false}	
	local r =  (gt+ (rnd(1,100)/100))
	local up = (r%2>1)--trueAndFalse[math.random(1, 2)]
	local left = (r%2>1) --= trueAndFalse[rnd(1, 2)]
	local right = not left--(r%2<1) -- trueAndFalse[rnd(1, 2)]
	local lr = rnd (0,100)
	if (sin(gt) +(rnd(-10,10)/10))   > 0 then 
	left=true right=false
	else
	left=false right= true
	end
	local down = not up --trueAndFalse[rnd(1, 2)]
	local shot = trueAndFalse[rnd(1, 2)]	
	return {up=up, left=left, right=right, down=down, shot=shot}
end
