--view {} --.canvas --cameraX, cameraY
splitScreen = false
function newView (canvasWidth, canvasHeight, viewName)
	local v = {
	canvas = love.graphics.newCanvas(canvasWidth, canvasHeight),
	canvasWidth = canvasWidth,
	canvasHeight = canvasHeight,
	viewName = viewName,
	cameraX = 400,
	cameraY = 300,
	debugString ="---"
	}
	return v
end

function showView (view,x,y, title)
	LG.setColor(1, 1, 1, 1)	
	LG.setLineWidth (2)
	LG.rectangle('line', x, y, view.canvasWidth, view.canvasHeight) --frame
	LG.setColor(0, 0, 0, 1)
	LG.rectangle('fill', x, y, view.canvasWidth, view.canvasHeight) --background
	LG.setBlendMode("alpha", "premultiplied")
	LG.setColor(1, 1, 1, 1)

	LG.draw (view.canvas,x,y)
	LG.setBlendMode("alpha")
	LG.print ("title:" .. title, x,y)
	LG.print ("viewName:"..view.viewName .. " cameraX/Y="
	..(view.cameraX or "nil") .."/".. (view.cameraY or "nil"), x,y+view.canvasHeight-20)
	LG.print ("dS:"..view.debugString,x,y+20)
end

function drawView (view)
	local drawTimeStart = love.timer.getTime()
	LG.push ()
	LG.origin ()
	LG.setCanvas(view.canvas)
	LG.clear ()
	--local tileOverDraw = 0	--fudgefactor: draw more tiles of level (zoomed out view or rotated)
	if view.viewName == "view2" then 
		--LG.scale (0.5,0.5) --end
	LG.translate (view.canvasWidth/2, view.canvasHeight/2)
	love.graphics.rotate(gplayers[2].angle)
	LG.translate (-view.canvasWidth/2, -view.canvasHeight/2)
	tileOverDraw = 2
	end
	--white testcircles to mark top-left and bottom-right corner of view-window
	LG.setColor(1, 1, 1, 1)	
	LG.circle("fill", 0,0, 20, 6)
	LG.circle("fill", view.canvasWidth,view.canvasHeight, 20, 6)
	--drawing actual content of view-window
	--LG.setColor(0, 0, 1, 1)
--	LG.circle("fill", math.random(0,view.canvasWidth), math.random(0,view.canvasHeight), 20, 5)
--	love.graphics.setColor(1, 0, 0, 1)
--	LG.circle("fill", math.random(0,view.canvasWidth), math.random(0,view.canvasHeight), 20, 5)

	LG.translate (-view.cameraX + view.canvasWidth/2, -view.cameraY + view.canvasHeight/2)
   	local tw=(view.canvasWidth/TILESIZE)
   	local th=(view.canvasHeight/TILESIZE)
   	local xstart=math.floor ((view.cameraX/TILESIZE)-(tw/2))   	
   	local xend=math.ceil ((view.cameraX/TILESIZE)+(tw/2))
   	local ystart=math.floor ((view.cameraY/TILESIZE)-(th/2))   	
   	local yend=math.ceil ((view.cameraY/TILESIZE)+(th/2))

   	drawLevel (xstart,xend , ystart,yend)
	--drawPlayers ()
	local drawnUnits = drawUnits (xstart*TILESIZE, ystart*TILESIZE, xend*TILESIZE, yend*TILESIZE )
	LG.pop ()
	LG.setCanvas()
	local drawTimeEnd = love.timer.getTime()
	view.debugString=xstart.."-"..xend.."/"..ystart.."-"..yend .. "||"..xend-xstart.."/"..yend-ystart
		 .. " drawnUnits:"..drawnUnits .." drawTime:"..drawTimeEnd-drawTimeStart

end
----view end
